within Conference2018;

model ElevatorModel
  Modelica.Mechanics.MultiBody.Parts.Body body1(m = 1) annotation(Placement(visible = true, transformation(origin = {46.307, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  inner Modelica.Mechanics.MultiBody.World world(gravityType = Modelica.Mechanics.MultiBody.Types.GravityTypes.UniformGravity) annotation(Placement(visible = true, transformation(origin = {-116.307, 8.32}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.MultiBody.Joints.Prismatic prismatic1(n = {0, 1, 0}, animation = true, useAxisFlange = true) annotation(Placement(visible = true, transformation(origin = {3.693, -16.588}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.MultiBody.Parts.BodyBox bodyBox1(length = 0.25, width = 0.125) annotation(Placement(visible = true, transformation(origin = {-36.307, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.MultiBody.Parts.Fixed fixed1(r = {0, 2, 0}, animation = false) annotation(Placement(visible = true, transformation(origin = {-78.01, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.MultiBody.Joints.Prismatic prismatic2(n = {0, 1, 0}, useAxisFlange = true, animation = false) annotation(Placement(visible = true, transformation(origin = {-51.307, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Translational.Sources.Position position1(useSupport = true, exact = false) annotation(Placement(visible = true, transformation(origin = {-52.507, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.Translational.Components.SpringDamper springDamper1(c = 40, d = 0.1, s_rel0 = -2, s_rel.start = -2, s_rel.fixed = true) annotation(Placement(visible = true, transformation(origin = {7.802, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.MultiBody.Sensors.AbsolutePosition absolutePosition1 annotation(Placement(visible = true, transformation(origin = {47.415, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Interfaces.RealInput position annotation(Placement(visible = true, transformation(origin = {-145, 56.718}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-96.667, 63.02}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
  Modelica.Blocks.Interfaces.RealOutput HeightOut annotation(Placement(visible = true, transformation(origin = {150, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Mechanics.MultiBody.Visualizers.FixedShape fixedShape1(shapeType = "box", length = 0.3, width = 0.3, height = 0.5, extra = 1, color = {0, 128, 255}, lengthDirection = {1, 0, 0}, widthDirection = {0, 0, 1}, r_shape = {-0.15, -0.25, 0}) annotation(Placement(visible = true, transformation(origin = {52.487, 32.766}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(prismatic2.frame_b, bodyBox1.frame_a) annotation(Line(visible = true, origin = {-43.807, 3}, points = {{2.5, 12}, {3.725, 12}, {3.725, 1}, {-3.725, 1}, {-3.725, -13}, {-2.5, -13}}, color = {95, 95, 95}));
  connect(prismatic2.frame_a, fixed1.frame_b) annotation(Line(visible = true, origin = {-64.722, 12.5}, points = {{3.415, 2.5}, {-0.063, 2.5}, {-0.063, -2.5}, {-3.288, -2.5}}, color = {95, 95, 95}));
  connect(prismatic1.frame_b, body1.frame_a) annotation(Line(visible = true, origin = {29.147, -13.294}, points = {{-15.454, -3.294}, {4.147, -3.294}, {4.147, 3.294}, {7.16, 3.294}}, color = {95, 95, 95}));
  connect(bodyBox1.frame_b, prismatic1.frame_a) annotation(Line(visible = true, origin = {-12.919, -13.294}, points = {{-13.388, 3.294}, {3.387, 3.294}, {3.387, -3.294}, {6.612, -3.294}}, color = {95, 95, 95}));
  connect(prismatic2.support, position1.support) annotation(Line(visible = true, origin = {-53.907, 32.744}, points = {{-1.4, -11.744}, {-1.4, 2.244}, {1.4, 2.244}, {1.4, 7.256}}, color = {0, 127, 0}));
  connect(position1.flange, prismatic2.axis) annotation(Line(visible = true, origin = {-40.494, 35.5}, points = {{-2.013, 14.5}, {2.413, 14.5}, {2.413, -14.5}, {-2.812, -14.5}}, color = {0, 127, 0}));
  connect(springDamper1.flange_a, prismatic1.support) annotation(Line(visible = true, origin = {-2.731, 2.447}, points = {{0.534, 12.553}, {-2.691, 12.553}, {-2.691, -6.035}, {2.424, -6.035}, {2.424, -13.035}}, color = {0, 127, 0}));
  connect(prismatic1.axis, springDamper1.flange_b) annotation(Line(visible = true, origin = {17.888, 2.206}, points = {{-6.194, -12.794}, {3.14, -12.794}, {3.14, 12.794}, {-0.085, 12.794}}, color = {0, 127, 0}));
  connect(body1.frame_a, absolutePosition1.frame_a) annotation(Line(visible = true, origin = {35.078, -25}, points = {{1.229, 15}, {-1.783, 15}, {-1.783, -15}, {2.337, -15}}, color = {95, 95, 95}));
  connect(position, position1.s_ref) annotation(Line(visible = true, origin = {-86.13, 53.359}, points = {{-58.87, 3.359}, {18.623, 3.359}, {18.623, -3.359}, {21.623, -3.359}}, color = {1, 37, 163}));
  connect(absolutePosition1.r[2], HeightOut) annotation(Line(visible = true, origin = {120.491, -20}, points = {{-62.076, -20}, {16.284, -20}, {16.284, 20}, {29.509, 20}}, color = {1, 37, 163}));
  connect(fixedShape1.frame_a, body1.frame_a) annotation(Line(visible = true, origin = {36.346, 11.383}, points = {{6.141, 21.383}, {-3.051, 21.383}, {-3.051, -21.383}, {-0.039, -21.383}}, color = {95, 95, 95}));
  annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, origin = {6.196, -37.682}, fillColor = {255, 255, 255}, lineThickness = 2.5, extent = {{-33.804, -24.997}, {33.804, 24.997}}), Line(visible = true, origin = {5.223, 40.944}, points = {{0, -51.984}, {0, 21.888}, {0, 30.096}}, thickness = 2.5), Rectangle(visible = true, origin = {4.664, 75.817}, fillColor = {255, 255, 255}, lineThickness = 2.5, extent = {{-27.795, -4.183}, {27.795, 4.183}}), Rectangle(visible = true, origin = {2.883, 1.967}, fillColor = {255, 255, 255}, extent = {{-87.117, -91.967}, {87.117, 91.967}}), Ellipse(visible = true, origin = {46.823, -30}, fillColor = {255, 255, 255}, lineThickness = 2.5, extent = {{-5.037, -5.037}, {5.037, 5.037}}), Ellipse(visible = true, origin = {46.988, -48.107}, fillColor = {255, 255, 255}, lineThickness = 2.5, extent = {{-5.037, -5.037}, {5.037, 5.037}}), Ellipse(visible = true, origin = {-35.202, -29.419}, fillColor = {255, 255, 255}, lineThickness = 2.5, extent = {{-5.037, -5.037}, {5.037, 5.037}}), Ellipse(visible = true, origin = {-35.037, -47.526}, fillColor = {255, 255, 255}, lineThickness = 2.5, extent = {{-5.037, -5.037}, {5.037, 5.037}})}), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})));
end ElevatorModel;
