within Conference2018;

model ElevatorTest
  Modelica.Blocks.Sources.Ramp ramp1(height = 2, duration = 2, startTime = 3, offset = 0) annotation(Placement(visible = true, transformation(origin = {-95, 53.104}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Conference2018.ElevatorModel elevatorModel3(springDamper1.d = 1, prismatic2.s.start = 2.45002916436040e-1, prismatic2.v.start = -8.94149154945321e-20, springDamper1.s_rel.start = -2.24524999999999e+0, springDamper1.v_rel.start = 5.90805480709874e-20, body1.cylinderColor.start = {0, 128, 255}, body1.sphereColor.start = {0, 128, 255}, bodyBox1.body.cylinderColor.start = {0, 128, 255}, bodyBox1.body.sphereColor.start = {0, 128, 255}, bodyBox1.color.start = {0, 128, 255}, bodyBox1.frameTranslation.color.start = {0, 128, 255}, fixed1.color.start = {155, 155, 155}, fixedShape1.color.start = {0, 128, 255}, prismatic1.boxColor.start = {255, 0, 0}, prismatic2.boxColor.start = {255, 0, 0}, world.gravityArrowColor.start = {0, 230, 0}, world.gravitySphereColor.start = {0, 230, 0}) annotation(Placement(visible = true, transformation(origin = {63.268, -5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Conference2018.Regulator regulator1(x.start = {2.07946611543408e-2, 2.00369692994406e-2, 1.56192716722350e-2, -4.31872395801629e-5, -1.06736292016759e-4}) annotation(Placement(visible = true, transformation(origin = {-2.246, -0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Modelica.Blocks.Math.Gain gain1(k = -1) annotation(Placement(visible = true, transformation(origin = {25, -25}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  Modelica.Blocks.Sources.Step step1(startTime = 3, height = 2) if false annotation(Placement(visible = true, transformation(origin = {-93.214, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(ramp1.y, regulator1.u[1]) annotation(Line(visible = true, origin = {-33.184, 26.552}, points = {{-50.816, 26.552}, {15.939, 26.552}, {15.939, -26.552}, {18.939, -26.552}}, color = {1, 37, 163}));
  connect(regulator1.y[1], elevatorModel3.position) annotation(Line(visible = true, origin = {40.723, 0.651}, points = {{-31.969, -0.651}, {9.545, -0.651}, {9.545, 0.651}, {12.878, 0.651}}, color = {1, 37, 163}));
  connect(elevatorModel3.HeightOut, gain1.u) annotation(Line(visible = true, origin = {58.817, -12.5}, points = {{14.451, 7.5}, {26.183, 7.5}, {26.183, -12.5}, {-21.817, -12.5}}, color = {1, 37, 163}));
  connect(gain1.y, regulator1.u[2]) annotation(Line(visible = true, origin = {-15.061, -12.5}, points = {{29.061, -12.5}, {-14.939, -12.5}, {-14.939, 12.5}, {0.815, 12.5}}, color = {1, 37, 163}));
  connect(step1.y, regulator1.u[1]) annotation(Line(visible = true, origin = {-32.738, 5}, points = {{-49.476, 5}, {15.492, 5}, {15.492, -5}, {18.492, -5}}, color = {1, 37, 163}));
  annotation(experiment(StartTime = 0.0, StopTime = 10.0, NumberOfIntervals = 2000, __Wolfram_Algorithm = "dassl", Tolerance = 1e-6, __Wolfram_MaxStepSize = 0, __Wolfram_EventHysteresisEpsilon = 1e-10, __Wolfram_AccurateEventDetection = true, __Wolfram_NonlinearSolverTolerance = 1e-12, __Wolfram_MaxInternalStepCount = 0, __Wolfram_CheckMinMax = false, __Wolfram_StopAtSteadyState = false, __Wolfram_SynchronizeWithRealTime = false), __Wolfram(PlotSet(plots = {Plot(name = "Response", preferred = true, subPlots = {SubPlot(curves = {Curve(x = time, y = elevatorModel3.HeightOut), Curve(x = time, y = step1.y), Curve(x = time, y = regulator1.u[1])})})}), Animation(windows = {Window(name = "Default", camera = "Default")}, cameras = {Camera(name = "Default", center = {0.16762973333693, 1.577407962383527, 0.2425336673371676}, distance = 10.1925371561072, rotation = {0.02684297097868629, -0.3226843641767039, 0.00929613704991232, 0.946080249165401})})), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Text(visible = true, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name")}));
end ElevatorTest;
